from collections.abc import Iterable
from datetime import datetime
from typing import Literal

from nonebot.adapters import Message
from nonebot_plugin_chatrecorder import MessageRecord
from nonebot_plugin_saa import PlatformTarget
from nonebot_plugin_uninfo import SceneType, Session, SupportAdapter, SupportScope

async def get_message_records(
    *,
    target: PlatformTarget | None = None,
    session: Session | None = None,
    filter_self_id: bool = True,
    filter_adapter: bool = True,
    filter_scope: bool = True,
    filter_scene: bool = True,
    filter_user: bool = True,
    self_ids: Iterable[str] | None = None,
    adapters: Iterable[str | SupportAdapter] | None = None,
    scopes: Iterable[str | SupportScope] | None = None,
    scene_types: Iterable[int | SceneType] | None = None,
    scene_ids: Iterable[str] | None = None,
    user_ids: Iterable[str] | None = None,
    exclude_self_ids: Iterable[str] | None = None,
    exclude_adapters: Iterable[str | SupportAdapter] | None = None,
    exclude_scopes: Iterable[str | SupportScope] | None = None,
    exclude_scene_types: Iterable[int | SceneType] | None = None,
    exclude_scene_ids: Iterable[str] | None = None,
    exclude_user_ids: Iterable[str] | None = None,
    time_start: datetime | None = None,
    time_stop: datetime | None = None,
    types: Iterable[Literal["message", "message_sent"]] | None = None,
) -> list[MessageRecord]: ...
async def get_messages(
    *,
    target: PlatformTarget | None = None,
    session: Session | None = None,
    filter_self_id: bool = True,
    filter_adapter: bool = True,
    filter_scope: bool = True,
    filter_scene: bool = True,
    filter_user: bool = True,
    self_ids: Iterable[str] | None = None,
    adapters: Iterable[str | SupportAdapter] | None = None,
    scopes: Iterable[str | SupportScope] | None = None,
    scene_types: Iterable[int | SceneType] | None = None,
    scene_ids: Iterable[str] | None = None,
    user_ids: Iterable[str] | None = None,
    exclude_self_ids: Iterable[str] | None = None,
    exclude_adapters: Iterable[str | SupportAdapter] | None = None,
    exclude_scopes: Iterable[str | SupportScope] | None = None,
    exclude_scene_types: Iterable[int | SceneType] | None = None,
    exclude_scene_ids: Iterable[str] | None = None,
    exclude_user_ids: Iterable[str] | None = None,
    time_start: datetime | None = None,
    time_stop: datetime | None = None,
    types: Iterable[Literal["message", "message_sent"]] | None = None,
) -> list[Message]: ...
async def get_messages_plain_text(
    *,
    target: PlatformTarget | None = None,
    session: Session | None = None,
    filter_self_id: bool = True,
    filter_adapter: bool = True,
    filter_scope: bool = True,
    filter_scene: bool = True,
    filter_user: bool = True,
    self_ids: Iterable[str] | None = None,
    adapters: Iterable[str | SupportAdapter] | None = None,
    scopes: Iterable[str | SupportScope] | None = None,
    scene_types: Iterable[int | SceneType] | None = None,
    scene_ids: Iterable[str] | None = None,
    user_ids: Iterable[str] | None = None,
    exclude_self_ids: Iterable[str] | None = None,
    exclude_adapters: Iterable[str | SupportAdapter] | None = None,
    exclude_scopes: Iterable[str | SupportScope] | None = None,
    exclude_scene_types: Iterable[int | SceneType] | None = None,
    exclude_scene_ids: Iterable[str] | None = None,
    exclude_user_ids: Iterable[str] | None = None,
    time_start: datetime | None = None,
    time_stop: datetime | None = None,
    types: Iterable[Literal["message", "message_sent"]] | None = None,
) -> list[str]: ...
